<%@ include file="/include.jsp"%>
<%@ include file="_styles.jsp" %>
<div class="applicationsContainer">
  <script type="text/javascript">
    if (window.authErrorTid) {
      window.clearTimeout(window.authErrorTid);
    }
  </script>
  <c:choose>
    <c:when test="${errorCode == 'newTokenRequired'}">
      <%@ include file="_newTokenRequired.jsp" %>
    </c:when>
    <c:when test="${errorCode == 'unknownError'}">
      <%@ include file="_unknownError.jsp" %>
    </c:when>
    <c:when test="${errorCode == 'tokenObtained'}">
      <%@ include file="_tokenObtained.jsp" %>
    </c:when>
    <c:otherwise>
      <script type="text/javascript">
        BS.HubApplicationsPopup.services = [];
        <c:forEach items="${services}" var="svc">
        BS.HubApplicationsPopup.services['${svc.id}'] = {
          id: '${svc.id}',
          homeUrl: '${svc.homeUrl}',
          name: '${svc.name}',
          applicationName: '${svc.applicationName}'
        };
        </c:forEach>
      </script>

      <c:set var="servicesNum" value="${fn:length(services)}"/>
      <c:if test="${servicesNum == 0}">
        <div class="grayNote">There are no <c:out value="${applicationName}"/> services available.</div>
      </c:if>
      <c:if test="${servicesNum > 0}">
        <div class="grayNote">Found <strong>${servicesNum}</strong> <c:out value="${applicationName}"/> service<bs:s val="${servicesNum}"/>.</div>
      </c:if>

      <ul class="menuList">
        <c:forEach items="${services}" var="svc">
          <li class="inplaceFiltered" onclick="BS.HubApplicationsPopup.useService('${svc.id}')">
            <c:out value="${svc.name}"/> (<a href="${svc.homeUrl}"><c:out value="${svc.homeUrl}"/>)</a>
          </li>
        </c:forEach>
      </ul>
    </c:otherwise>
  </c:choose>
</div>
