/*
 * Copyright 2000-2016 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

BS.HubApplicationsPopup = new BS.Popup('hubApplications', {
  url: window['base_uri'] + "/hubPlugin/applications.html",
  method: "get",
  hideDelay: 0,
  hideOnMouseOut: false,
  hideOnMouseClickOutside: true
});

BS.HubApplicationsPopup.showPopup = function(nearestElement, appName) {
  this.options.parameters = "applicationName=" + appName;
  var that = this;

  window.HubPopups_updatePopup = function() {
    that.hidePopup(0);
    that.showPopupNearElement(nearestElement);
  };

  this.showPopupNearElement(nearestElement);
};

BS.HubApplicationsPopup.useService = function(serviceId) {
  if (window.hubServiceCallback) {
    window.hubServiceCallback(BS.HubApplicationsPopup.services[serviceId]);
  }
  BS.HubApplicationsPopup.hidePopup();
};

BS.HubApplicationsPopup.installControl = function(containerId, applicationName, callback) {
  window.hubServiceCallback = callback;
  $j('#' + containerId).html('<span style="cursor: pointer"><i class="icon-magic" title="Pick from JetBrains Hub" onclick="BS.HubApplicationsPopup.showPopup(this, ' + "'" + applicationName + "'" +')"></i></span>');
};

BS.HubServiceProjectsPopup = new BS.Popup('hubServiceProjects', {
  url: window['base_uri'] + "/hubPlugin/serviceProjects.html",
  method: "get",
  hideDelay: 0,
  hideOnMouseOut: false,
  hideOnMouseClickOutside: true
});

BS.HubServiceProjectsPopup.showPopup = function(nearestElement) {
  this.options.parameters = "serviceQuery=" + window.serviceQueryCallback();
  var that = this;

  window.HubPopups_updatePopup = function() {
    that.hidePopup(0);
    that.showPopupNearElement(nearestElement);
  };

  this.showPopupNearElement(nearestElement);
};

BS.HubServiceProjectsPopup.useProject = function(projectId) {
  if (window.hubProjectCallback) {
    window.hubProjectCallback(BS.HubServiceProjectsPopup.projects[projectId]);
  }
  BS.HubServiceProjectsPopup.hidePopup();
};

BS.HubServiceProjectsPopup.installControl = function(containerId, serviceQueryCallback, callback) {
  window.hubProjectCallback = callback;
  window.serviceQueryCallback = serviceQueryCallback;
  $j('#' + containerId).html('<span style="cursor: pointer"><i class="icon-magic" title="Pick from JetBrains Hub" onclick="BS.HubServiceProjectsPopup.showPopup(this)"></i></span>');
};
