<%@ include file="/include.jsp"%>
<%@ include file="_styles.jsp" %>
<div class="applicationsContainer">
  <script type="text/javascript">
    if (window.authErrorTid) {
      window.clearTimeout(window.authErrorTid);
    }
  </script>
  <c:choose>
    <c:when test="${errorCode == 'newTokenRequired'}">
      <%@ include file="_newTokenRequired.jsp" %>
    </c:when>
    <c:when test="${errorCode == 'unknownError'}">
      <%@ include file="_unknownError.jsp" %>
    </c:when>
    <c:when test="${errorCode == 'tokenObtained'}">
      <%@ include file="_tokenObtained.jsp" %>
    </c:when>
    <c:otherwise>
      <script type="text/javascript">
        BS.HubServiceProjectsPopup.projects = [];
        <c:forEach items="${projects}" var="project">
        BS.HubServiceProjectsPopup.projects['${project.id}'] = {
          id: '${project.id}',
          homeUrl: '${project.homeUrl}',
          name: '${project.name}',
          key: '${project.key}'
        };
        </c:forEach>
      </script>

      <c:set var="projectsNum" value="${fn:length(projects)}"/>
      <c:if test="${projectsNum == 0}">
        <div class="grayNote">No projects found.</div>
      </c:if>
      <c:if test="${projectsNum > 0}">
        <div class="grayNote">Found <strong>${projectsNum}</strong> project<bs:s val="${projectsNum}"/>.</div>
      </c:if>
      <c:if test="${projectsNum > 10}">
      <div class="filter">
        <bs:inplaceFilter containerId="projectsContainerId" activate="true" filterText="&lt;filter projects>"/>
      </div>
      </c:if>

      <ul class="menuList" id="projectsContainerId">
        <c:forEach items="${projects}" var="project">
          <li class="inplaceFiltered" onclick="BS.HubServiceProjectsPopup.useProject('${project.id}')">
            <c:out value="${project.name}"/> (<c:out value="${project.key}"/>)
          </li>
        </c:forEach>
      </ul>
    </c:otherwise>
  </c:choose>
</div>
