BS.ProjectRingSettings = {
  matchProject: function(projectExternalId) {
    BS.ProjectRingSettings._beforeAjax();
    return BS.ProjectRingSettings.doMatchProject(projectExternalId, $("ringProjectId").value, BS.ProjectRingSettings._onComplete);
  },

  doMatchProject: function(projectExternalId, ringProjectId, onComplete) {
    BS.ajaxRequest(window['base_uri'] + '/hubPlugin/matchProject.html', {
      parameters: {
        projectExternalId: projectExternalId,
        ringProjectId: ringProjectId
      },
      onComplete: onComplete
    });
    return false;
  },

  matchSuggestedProject: function(projectExternalId, suggestedRingProjectId) {
    BS.ProjectRingSettings._doBeforeAjax("matchProjectForm-" + projectExternalId, "matchProjectProgress-" + projectExternalId);
    BS.ProjectRingSettings.doMatchProject(projectExternalId, suggestedRingProjectId, function(response) {
      BS.ProjectRingSettings._doOnComplete(response, "matchProjectForm-" + projectExternalId, "matchProjectProgress-" + projectExternalId, function(id, elem) {
        BS.PluginPropertiesForm.propertiesErrorsHandler(id + "-" + projectExternalId, elem);
      }, function() {
        BS.Util.fadeOutAndDelete("#ringDiv-" + projectExternalId);
      });
    });
  },

  _onComplete: function(response) {
    BS.ProjectRingSettings._doOnComplete(response, "matchProjectForm", "matchProjectProgress", BS.PluginPropertiesForm.propertiesErrorsHandler, function() {
      $("ringDiv").refresh();
    });
  },

  _doOnComplete: function(response, matchProjectForm, matchProjectProgress, generalErrorHandler, finalAction) {
    BS.Util.hide(matchProjectProgress);
    var responseXML = response.responseXML;
    if (responseXML && BS.XMLResponse.processErrors(responseXML, {}, generalErrorHandler)) {
      BS.Util.reenableForm($(matchProjectForm));
      return;
    }
    finalAction();
  },

  _beforeAjax: function() {
    BS.ProjectRingSettings._doBeforeAjax("matchProjectForm", "matchProjectProgress");
  },

  _doBeforeAjax: function(matchProjectForm, matchProjectProgress) {
    BS.Util.disableFormTemp($(matchProjectForm));
    BS.Util.show(matchProjectProgress);
  }
};