<%@ include file="/include.jsp" %>
<jsp:useBean id="ringSettingsBean" scope="request" type="com.jetbrains.teamcity.ring.web.settings.RingSettingsGeneralBean"/>

<br/>

<c:url value="/admin/admin.html?item=serverConfigGeneral" var="globalSettingsUrl"/>
<c:set var="hubStatus" value="${ringSettingsBean.status}"/>

<form action="#" id="ringSettingsForm" onsubmit="return false;">
<c:choose>
  <c:when test="${empty ringSettingsBean.serviceId or not hubStatus.registered}">
    <table class="runnerFormTable">
      <tr>
        <td style="vertical-align: top">
          <label for="hubUrlField">Hub URL:</label>
        </td>
        <td>
          <forms:textField name="hubUrl" id="hubUrlField" value="${ringSettingsBean.hubUrl}" className="longField"/>
          <span class="error" id="error_hubUrl"></span>
        </td>
      </tr>
      <tr>
        <td style="vertical-align: top">TeamCity Server URL:</td>
        <td>
          <c:out value="${ringSettingsBean.serverURL}"/>
          <span class="smallNote">Server URL is defined on <a href="${globalSettingsUrl}">Global settings</a> page.</span>
        </td>
      </tr>
      <tr>
        <td style="vertical-align: top"><label for="additionalUrls">Additional URLs:</label></td>
        <td>
          <forms:textField name="additionalUrls" expandable="true" className="longField" minheight="40"/>
          <span class="smallNote">If this TeamCity server is available on different URLs, please provide all of them separated by new line.</span>
        </td>
      </tr>
    </table>

    <c:if test="${not empty ringSettingsBean.serviceId and not hubStatus.registered}">
      Status: <span style="color: red"><c:out value="${hubStatus.statusMessage}"/></span>
    </c:if>

    <br/>
    <br/>

    <input type="button" class="btn" value="Register TeamCity Service in Hub" onclick="return BS.RingSettings.registerHubService(this.form.hubUrl.value, this.form.additionalUrls.value);"/>
    <forms:progressRing id="ringActionProgress" style="display: none; float: none;"/>

  </c:when>
  <c:otherwise>
    <div class="editHubUrl" style="display: none;">
      <label for="hubUrlField">Hub URL:</label>
      <forms:textField name="hubUrl" id="hubUrlField" value="${ringSettingsBean.hubUrl}" className="longField"/>
      <input class="submitButton btn" type="submit" value="Save" onclick="return BS.RingSettings.updateHubUrl();">
      <forms:progressRing id="hubUrlProgress" style="display: none; float: none;"/>

      <span class="error" id="error_hubUrl"></span>
    </div>
    <div class="showHubUrl">
      <label>Hub URL:</label> <span><c:out value="${ringSettingsBean.hubUrl}"/></span> <a href="#" onclick="$j('.editHubUrl').show(); $j('.showHubUrl').hide()">Edit</a>
    </div>
    <br/>
    <br/>

    <c:choose>
      <c:when test="${hubStatus.verified}"><c:set var="statusColor" value="green"/></c:when>
      <c:otherwise><c:set var="statusColor" value="red"/></c:otherwise>
    </c:choose>
    Status: <span style="color: ${statusColor}"><c:out value="${hubStatus.statusMessage}"/></span>

    <br/>
    <br/>

    <c:choose>
      <c:when test="${hubStatus.urlDoesNotMatch}">
        <div>
          <input type="button" class="btn" value="Update TeamCity Service URLs in Hub" onclick="return BS.RingSettings.updateHubService();"/>
          <forms:progressRing id="ringActionProgress" style="display: none; float: none;"/>
        </div>
      </c:when>
      <c:when test="${hubStatus.registered}">
        <div>
          <input type="button" class="btn" value="Unregister TeamCity Service" onclick="return BS.RingSettings.unregisterHubService();"/>
          <forms:progressRing id="ringActionProgress" style="display: none; float: none;"/>
        </div>
      </c:when>
    </c:choose>

    <c:if test="${hubStatus.registered}">
    <br/>
    <div>
      <a href="<c:url value='${ringSettingsBean.teamCityRingServiceUrl}'/>">View TeamCity service page in Hub</a>
    </div>
    </c:if>

  </c:otherwise>
</c:choose>
</form>
