<%@ page import="com.jetbrains.teamcity.ring.web.settings.export.RingExportDialogController" %>
<%@ include file="/include-internal.jsp" %>
<jsp:useBean id="ringSettingsBean" scope="request" type="com.jetbrains.teamcity.ring.web.settings.RingSettingsSynchronizationBean"/>

<div class="groupingTitle">Settings</div>

<form action="#" id="ringSyncSettingsForm" onsubmit="return false;">
  <c:set var="syncOptions" value="${ringSettingsBean.syncOptions}"/>
  <c:url var="miscTab" value="/admin/admin.html?item=hub&tab=misc"/>
  <div>
    <forms:checkbox name="syncUsers" checked="${syncOptions.userSyncEnabled}" onclick="{
      $('updateUsers').checked = this.checked;
      if (!this.checked) {
        $('updateUsers').checked = false;
      }

      if ($('syncGroups') != null) {
        if (!this.checked || $('syncGroups').checked) {
          $('assignUsers').checked = $('deassignUsers').checked = this.checked;
        }
      }
    }"/>
    <label for="syncUsers">Enable users synchronization</label>
    <div style="padding-left: 20px;">
      <div>
        <forms:checkbox name="updateUsers" checked="${syncOptions.userSyncEnabled}" onclick="{
           if (this.checked) { $('syncUsers').checked = true; }
           if (!this.checked && $('syncUsers').checked) { $('syncUsers').click(); }
        }"/>
        <label for="updateUsers">Update user details in TeamCity</label>
        <div class="smallNote" style="margin-left: 2em">Update the name, email and VCS usernames in TeamCity with data from the user profile in Hub</div>
      </div>
      <div>
        <forms:checkbox name="createUsers" checked="${syncOptions.createUsers}" onclick="if (this.checked) { $('syncUsers').checked = true; }"/>
        <label for="createUsers">Create user accounts in TeamCity</label>
        <div class="smallNote" style="margin-left: 2em">If a user account exists in Hub and is matched <a href="${miscTab}">by the filter</a>, also create it in TeamCity</div>
      </div>
      <div>
        <forms:checkbox name="deleteUsers" checked="${syncOptions.deleteUsers}" onclick="if (this.checked) { $('syncUsers').checked = true; }"/>
        <label for="deleteUsers">Delete user accounts from TeamCity</label>
        <div class="smallNote" style="margin-left: 2em">If a user account is deleted in Hub or is not matched <a href="${miscTab}">by the filter</a>, delete it in TeamCity</div>
      </div>
    </div>
  </div>
  <c:if test="${intprop:getBoolean('teamcity.hubPlugin.groupSync.options.enabled')}">
    <div>
      <forms:checkbox name="syncGroups" checked="${syncOptions.groupSyncEnabled}" onclick="$('createGroups').checked = $('deleteGroups').checked = $('addSubgroups').checked = $('removeSubgroups').checked = this.checked; if (!this.checked || $('syncUsers').checked) { $('assignUsers').checked = $('deassignUsers').checked = this.checked; }"/>
      <label for="syncGroups">Synchronize groups</label>
      <div style="padding-left: 20px;">
        <div>
          <forms:checkbox name="createGroups" checked="${syncOptions.createGroups}" onclick="if (this.checked) { $('syncGroups').checked = true; }"/>
          <label for="createGroups">Create groups</label>
        </div>
        <div>
          <forms:checkbox name="deleteGroups" checked="${syncOptions.deleteGroups}" onclick="if (this.checked) { $('syncGroups').checked = true; }"/>
          <label for="deleteGroups">Delete groups</label>
        </div>
        <div>
          <forms:checkbox name="assignUsers" checked="${syncOptions.assignUsers}" onclick="if (this.checked) { $('syncUsers').checked = $('syncGroups').checked = true; }"/>
          <label for="assignUsers">Add users to groups</label>
        </div>
        <div>
          <forms:checkbox name="deassignUsers" checked="${syncOptions.deassignUsers}" onclick="if (this.checked) { $('syncUsers').checked = $('syncGroups').checked = true; }"/>
          <label for="deassignUsers">Remove users from groups</label>
        </div>
        <div>
          <forms:checkbox name="addSubgroups" checked="${syncOptions.addSubgroups}" onclick="if (this.checked) { $('syncGroups').checked = true; }"/>
          <label for="addSubgroups">Add subgroups to groups</label>
        </div>
        <div>
          <forms:checkbox name="removeSubgroups" checked="${syncOptions.removeSubgroups}" onclick="if (this.checked) { $('syncGroups').checked = true; }"/>
          <label for="removeSubgroups">Remove subgroups from groups</label>
        </div>
      </div>
    </div>
  </c:if>
  <br/>
  <input class="submitButton btn" type="submit" value="Save" onclick="return BS.RingSettings.updateSyncSettings();">
  <forms:progressRing id="ringSyncSettingsProgress" style="display: none; float: none;"/>
  <input type="hidden" id="curSyncUsers" value="${syncOptions.userSyncEnabled}"/>
  <input type="hidden" id="curCreateUsers" value="${syncOptions.createUsers}"/>
  <input type="hidden" id="curDeleteUsers" value="${syncOptions.deleteUsers}"/>
</form>

<br/>

<div class="groupingTitle">Synchronization</div>

<div>
  <form action="#" id="ringSyncForm" onsubmit="return false;">
    <input class="submitButton btn" type="submit" value="Synchronize now" id="ringSubmit"
           <c:if test="${not ringSettingsBean.idle}">disabled="disabled"</c:if> onclick="return BS.RingSettings.triggerSync();">
    State: <strong><c:out value="${ringSettingsBean.stateString}"/></strong>
    <c:set var="syncProgressStyle"><c:if test="${!ringSettingsBean.syncInProgress}">display: none; </c:if>float: none; margin-left: 5px;</c:set>
    <forms:progressRing id="ringSyncProgress" style="${syncProgressStyle}"/>
  </form>

  <c:if test="${ringSettingsBean.idle}">
    <c:set var="stats" value="${ringSettingsBean.statistics}"/>
    <div style="margin-top: 2em;">
      Last synchronization summary (finished <bs:date value="${stats.finishTime}" smart="true" no_smart_title="true"/>):
      <c:if test="${stats.userSyncEnabled}">
        <div>
          Found <b><c:out value="${stats.remoteUsers}"/></b> users in Hub,
          <b><c:out value="${stats.usersMatched}"/></b> are matched to TeamCity users.
        </div>
      </c:if>

      <c:if test="${stats.groupSyncEnabled}">
        <div>
          Found <b><c:out value="${stats.remoteGroups}"/></b> groups in Hub,
          <b><c:out value="${stats.groupsMatched}"/></b> are matched to TeamCity groups.
        </div>
      </c:if>

      <br>

      <div>
        Statistics:
        <c:set var="userChanges" value="${stats.usersCreated + stats.usersDeleted + stats.usersUpdated}"/>
        <c:set var="groupChanges" value="${stats.groupsCreated + stats.groupsDeleted + stats.groupsUpdated}"/>
        <c:choose>
          <c:when test="${userChanges + groupChanges == 0}">no users <c:if test="${stats.groupSyncEnabled}">and groups</c:if> modified.</c:when>
          <c:otherwise>
            <c:if test="${userChanges == 0}">no users modified,</c:if>
            <c:if test="${userChanges > 0}">
              ${stats.usersCreated > 0 ? stats.usersCreated : 'no'} user<bs:s val="${stats.usersCreated}"/> created,
              ${stats.usersDeleted > 0 ? stats.usersDeleted : 'no'} user<bs:s val="${stats.usersDeleted}"/> deleted,
              ${stats.usersUpdated > 0 ? stats.usersUpdated : 'no'} user<bs:s val="${stats.usersUpdated}"/> updated,
            </c:if>
            <c:if test="${groupChanges == 0}">no groups modified.</c:if>
            <c:if test="${groupChanges > 0}">
              ${stats.groupsCreated > 0 ? stats.groupsCreated : 'no'} group<bs:s val="${stats.groupsCreated}"/> created,
              ${stats.groupsDeleted > 0 ? stats.groupsDeleted : 'no'} group<bs:s val="${stats.groupsDeleted}"/> deleted,
              ${stats.groupsUpdated > 0 ? stats.groupsUpdated : 'no'} group<bs:s val="${stats.groupsUpdated}"/> updated.
            </c:if>
          </c:otherwise>
        </c:choose>
      </div>
    </div>

    <c:if test="${ringSettingsBean.hasErrors}">
      <p>
        Encountered <strong><c:out value="${ringSettingsBean.lastErrorsNumber}"/></strong> errors during
        users synchronization.
        <div class="attentionComment">
          <c:forEach var="message" items="${ringSettingsBean.lastErrors}">
            <div><c:out value="${message}"/></div>
          </c:forEach>
          <c:if test="${ringSettingsBean.errorsClipped}">
            <div>And ${ringSettingsBean.lastErrorsNumber - ringSettingsBean.defaultErrorsNumber} more. Please see the TeamCity log.</div>
          </c:if>
        </div>
      </p>
    </c:if>
  </c:if>
</div>

<c:if test="${intprop:getBoolean('teamcity.hubPlugin.export.options.enabled')}">
  <br/>

  <div class="groupingTitle">Export</div>

  <div class="export-button">
    <c:set var="exportInfoProvider" value="${ringSettingsBean.exportInfoProvider}"/>
    <c:set var="userToExportCount" value="${exportInfoProvider.userToExportCount}"/>
    <c:set var="groupToExportCount" value="${exportInfoProvider.userGroupToExportCount}"/>
    <input class="submitButton btn" type="submit" value="Export..." id="ringExport" onclick="return BS.RingExportDialog.showExportDialog();" <c:if test="${userToExportCount == 0 and groupToExportCount == 0}">disabled="disabled"</c:if>>
    <c:choose>
      <c:when test="${userToExportCount == 0 and groupToExportCount == 0}"><strong>No users or user groups to export</strong></c:when>
      <c:otherwise><strong><c:if test="${userToExportCount != 0}">${userToExportCount} user<bs:s val="${userToExportCount}"/></c:if><c:if test="${userToExportCount != 0 and groupToExportCount != 0}"> and </c:if><c:if test="${groupToExportCount != 0}">${groupToExportCount} user group<bs:s val="${groupToExportCount}"/></c:if> could be exported to Hub</strong></c:otherwise>
    </c:choose>
    <br/><br/>
  </div>

  <c:set var="exportPath" value='<%=RingExportDialogController.PATH%>'/>
  <c:url var="exportUrl" value='${exportPath}'/>
  <bs:modalDialog formId="ringExportForm"
                  title="Export Users and User Groups to Hub"
                  action="${exportUrl}"
                  closeCommand="BS.RingExportDialog.close();"
                  saveCommand="BS.RingExportDialog.submit()">
    <div id="ringExportDialog">
      <forms:progressRing style="float: none;" id="ringExportDialogProgressRing"/>
      <span>Loading...</span>
    </div>

    <div class="popupSaveButtonsBlock">
      <forms:submit label="Export" id="ringExportButton" disabled="${true}"/>
      <forms:cancel onclick="BS.RingExportDialog.close()"/>
      <forms:progressRing id="ringExportProgress" style='display:none;'/>
    </div>
  </bs:modalDialog>

  <div class="export-reports">
    <c:set var="exportStatistics" value="${ringSettingsBean.exportStatistics}"/>
    <c:set var="exportedUserCount" value="${exportStatistics.successfulUserReportCount}"/>
    <c:set var="exportedGroupCount" value="${exportStatistics.successfulUserGroupReportCount}"/>
    <c:set var="failedUserCount" value="${exportStatistics.errorUserReportCount}"/>
    <c:set var="failedGroupCount" value="${exportStatistics.errorUserGroupReportCount}"/>
    <c:set var="lastErrorReports" value="${exportStatistics.lastErrorReports}"/>

    <c:if test="${exportedUserCount == 0 and exportedGroupCount == 0 and failedUserCount == 0 and failedGroupCount == 0}">
      <span>No export reports found</span>
    </c:if>
    <c:if test="${exportedUserCount != 0 or exportedGroupCount != 0}">
      <span><c:if test="${exportedUserCount != 0}">${exportedUserCount} user<bs:s val="${exportedUserCount}"/></c:if><c:if test="${exportedUserCount != 0 and exportedGroupCount != 0}"> and </c:if><c:if test="${exportedGroupCount != 0}">${exportedGroupCount} user group<bs:s val="${exportedGroupCount}"/></c:if><bs:were_was val="${exportedUserCount + exportedGroupCount}"/> successfully exported</span>
    </c:if>
    <c:if test="${(exportedUserCount != 0 or exportedGroupCount != 0) and (failedUserCount != 0 or failedGroupCount != 0)}">
      <br/>
    </c:if>
    <c:if test="${failedUserCount != 0 or failedGroupCount != 0}">
      <span><c:if test="${failedUserCount != 0}">${failedUserCount} user<bs:s val="${failedUserCount}"/></c:if><c:if test="${failedUserCount != 0 and failedGroupCount != 0}"> and </c:if><c:if test="${failedGroupCount != 0}">${failedGroupCount} user group<bs:s val="${failedGroupCount}"/></c:if><bs:were_was val="${failedUserCount + failedGroupCount}"/> not exported</span>
    </c:if>
    <c:if test="${not empty lastErrorReports}">
      <br/><br/>
      <c:forEach items="${lastErrorReports}" var="report">
        <%--@elvariable id="report" type="com.jetbrains.teamcity.ring.sync.accounts.export.ExportReport"--%>
        <div><c:out value="${report.displayText}"/></div>
      </c:forEach>
      <c:set var="leftErrorsCount" value="${failedUserCount + failedGroupCount - fn:length(lastErrorReports)}"/>
      <c:if test="${leftErrorsCount > 0}">
        <div>${leftErrorsCount} more error<bs:s val="${leftErrorsCount}"/><bs:are_is val="${leftErrorsCount}"/> not shown, please see the TeamCity logs for details</div>
      </c:if>
    </c:if>
  </div>
</c:if>

<c:if test="${ringSettingsBean.syncInProgress}">
  <script type="text/javascript">
    setTimeout(function() {
      $("ringDiv").refresh();
    }, 2000);
  </script>
</c:if>
